using System;
using System.Collections;
using System.Reflection;
using System.Xml;

namespace AspectWeaver.Advices
{
	public class AroundBody : BaseAdvice
	{
		public AroundBody(XmlNode adviceNode, XmlDocument baseDoc, Hashtable aspectDocs, WeaveLogger logger) : base(adviceNode, baseDoc, aspectDocs, logger)
		{
		}

		public override void DoWeave()
		{
			foreach(XmlNode targetNode in GetTargetNodes())
			{
				AddAffectedElementLog(Utils.GetElementDesc(targetNode));

				//get code to be added first
				XmlNodeList codeNodes = Utils.CreateCloneCodeNodes(((XmlDocument)aspectDocs[adviceNode.SelectSingleNode("Code").Attributes["aspectAssemblyUniqueName"].InnerXml]).SelectNodes(adviceNode.SelectSingleNode("Code").Attributes["aspectXPath"].InnerXml + "/Instruction"));

				// clear old code and local variables
				Utils.RemoveNodesFromTheirParentNode(targetNode.SelectNodes("Local"));
				Utils.RemoveNodesFromTheirParentNode(targetNode.SelectNodes("Instruction[@code != 'ret']"));

				Utils.ReplaceGetArgumentsWithLocalCode(codeNodes, targetNode);
				Utils.IntroduceLocalVariables(codeNodes, targetNode);
				Utils.ReplaceGetContextInfoWithLocalCode(codeNodes, targetNode);

				//get ref code node
				XmlNode refNode = targetNode.SelectSingleNode("Instruction[@code = 'ret']");

				//do add code
				Utils.InsertCodeNodesBefore(codeNodes, refNode);
			}
		
			SetStatusLog("weaved successfully");
		}
	}
}
