using System;
using System.Reflection;
using System.Xml;

namespace AspectWeaver.Advices
{
	public class ImplementInterface : BaseAdvice
	{
		public ImplementInterface(XmlNode adviceNode, XmlDocument baseDoc, WeaveLogger logger) : base(adviceNode, baseDoc, logger)
		{
		}

		public override void DoWeave()
		{
			foreach (XmlNode nodeToBeImplementedInterface in GetTargetNodes())
			{
				AddAffectedElementLog(Utils.GetElementDesc(nodeToBeImplementedInterface));

				XmlNode newImplementInterface = baseDoc.CreateElement("ImplementsInterface");
				newImplementInterface.InnerXml = adviceNode.SelectSingleNode("InterfaceType").InnerXml;
				nodeToBeImplementedInterface.InsertBefore(newImplementInterface, nodeToBeImplementedInterface.FirstChild);
			}

			SetStatusLog("weaved successfully");
		}

	}
}
