using System;
using System.Reflection;
using System.Xml;

namespace AspectWeaver.Advices
{
	public class MakeSealed : BaseAdvice
	{
		public MakeSealed(XmlNode adviceNode, XmlDocument baseDoc, WeaveLogger logger) : base(adviceNode, baseDoc, logger)
		{
		}

		public override void DoWeave()
		{
			foreach (XmlNode nodeToBeMakedSealed in GetTargetNodes())
			{
				AddAffectedElementLog(Utils.GetElementDesc(nodeToBeMakedSealed));

				nodeToBeMakedSealed.Attributes["isSealed"].InnerXml = "True";
			}

			SetStatusLog("weaved successfully");
		}

	}
}
