using System;
using System.Reflection;
using System.Xml;

namespace AspectWeaver.Advices
{
	public class MakeSerializable : BaseAdvice
	{
		public MakeSerializable(XmlNode adviceNode, XmlDocument baseDoc, WeaveLogger logger) : base(adviceNode, baseDoc, logger)
		{
		}

		public override void DoWeave()
		{
			foreach (XmlNode nodeToBeMakedSerializable in GetTargetNodes())
			{
				AddAffectedElementLog(Utils.GetElementDesc(nodeToBeMakedSerializable));

				nodeToBeMakedSerializable.Attributes["isSerializable"].InnerXml = "True";
			}

			SetStatusLog("weaved successfully");
		}

	}
}
