using System;
using System.Reflection;
using System.Xml;

namespace AspectWeaver.Advices
{
	public class MakeUnsealed : BaseAdvice
	{
		public MakeUnsealed(XmlNode adviceNode, XmlDocument baseDoc, WeaveLogger logger) : base(adviceNode, baseDoc, logger)
		{
		}

		public override void DoWeave()
		{
			foreach (XmlNode nodeToBeMakedUnsealed in GetTargetNodes())
			{
				AddAffectedElementLog(Utils.GetElementDesc(nodeToBeMakedUnsealed));

				nodeToBeMakedUnsealed.Attributes["isSealed"].InnerXml = "False";
			}

			SetStatusLog("weaved successfully");
		}

	}
}
