using System;
using System.Reflection;
using System.Xml;

namespace AspectWeaver.Advices
{
	public class SetBaseType : BaseAdvice
	{
		public SetBaseType(XmlNode adviceNode, XmlDocument baseDoc, WeaveLogger logger) : base(adviceNode, baseDoc, logger)
		{
		}

		public override void DoWeave()
		{
			foreach (XmlNode nodeToBeSetBaseType in GetTargetNodes())
			{
				AddAffectedElementLog(Utils.GetElementDesc(nodeToBeSetBaseType));

				nodeToBeSetBaseType.Attributes["baseType"].InnerXml = adviceNode.SelectSingleNode("BaseType").InnerXml;
			}
			
			SetStatusLog("weaved successfully");
		}
	}
}
