using System;
using System.Reflection;
using AspectWeaver.Aspects;

namespace TestAspectLib
{
	public class TestAspectClass : Aspect
	{
		public TestAspectClass()
		{
		}

		private string fieldToBeIntroduced = "fieldToBeIntroduced";

		[Introduce("//Type[@name='TestClass']")]
		private string fieldToBeIntroducedByCustomAttribute = "fieldToBeIntroducedByCustomAttribute";

		public void MethodToBeIntroduced()
		{
		}

		public void CodeBeforeConstructorCall()
		{
			Console.Write("CodeBeforeConstructorCall");
		}

		public void CodeAfterConstructorCall()
		{
			Console.Write("CodeAfterConstructorCall");
		}

		[BeforeMethodCall("//Method[@name='TestStaticMethod']"), BeforeMethodCall("//Method[@name='TestBeforeStaticMethodCall']")]
		public void CodeBeforeMethodCall()
		{
			Console.Write("CodeBeforeMethodCall");
		}

		public void CodeAfterMethodCall()
		{
			Console.Write("CodeAfterMethodCall");
		}

		public void CodeInlineAtStart()
		{
			Console.Write("CodeInlineAtStart");
		}

		public void CodeInlineBeforeReturn()
		{
			Console.Write("CodeInlineBeforeReturn");
		}

		public void CodeAroundedMethodBody()
		{
			Console.Write("CodeAroundedMethodBody");
		}

		[Introduce("//Type[@name='TestClass']")]
		public void MethodToBeIntrodcuedByCustomAttribute()
		{
		}

		[InlineAtStart("//Method[@name='MethodToBeTestedGetContextInfoAndGetArgumments']"), BeforeMethodCall("//Method[@name='MethodToBeTestedGetContextInfoAndGetArgumments']")]
		public void CodeToTestGetContextInfoAndGetArgumments()
		{
			string contextInfo = GetContextInfo();
			Console.Write(contextInfo + "\n\n");
			object[] args = GetArguments();
			Console.Write(args.Length.ToString());
		}
	}

	public class ClassToBeIntroduced
	{
	}

	[Introduce()]
	public class ClassToBeIntroducedByCustomAttribute
	{
		public void TestMethod()
		{
			for (int i = 0; i < 3; i++)
			{
				if (i == 1)
				{
					continue;	
				}
				else if (i == 2)
				{
					break;
				}
				int j = 9;
			}
		}
	}

}
