/*
 * Copyright (c) 2004 DotNetGuru and the individuals listed
 * on the ChangeLog entries.
 *
 * Authors :
 *   Evain Jb (jb@evain.net)
 *
 * This is a free software distributed under a BSD license
 * See LICENSE.BSD file for more details
 *
 *****************************************************************************/

namespace Ilml {

	using System;
	using System.Reflection;

    /// <summary>
    /// Factory used to build IIlmlParser
    /// It is the entry point of the ILML Library
    /// </summary>
    public sealed class IlmlParserFactory {

        private IlmlParserFactory() {}

        private static IIlmlParser m_parser = new RailParser();

        /// <summary>
        /// Factory method that returns a IIlmlParser
        /// </summary>
        /// <returns>An IIlmlParser</returns>
        public static IIlmlParser GetParser() {			
            return new RailParser();
        }
    }
}