/*
 * Copyright (c) 2004 DotNetGuru and the individuals listed
 * on the ChangeLog entries.
 *
 * Authors :
 *   Thomas Gil (thomas.gil@dotnetguru.org)
 *   Evain Jb   (jb@evain.net)
 *
 * This is a free software distributed under a BSD license
 * See LICENSE.BSD file for more details
 *
 *****************************************************************************/

namespace Ilml.Adapters {

    using System;
    using System.Xml;
    using System.Xml.XPath;

    using Rail.MSIL;
    using Rail.Reflect;

    internal sealed class LocalAdapter : XmlAdapter {

        #region singleton implementation

        private LocalAdapter() : base("Local")  {}
        public static readonly LocalAdapter Instance = 
            new LocalAdapter();

        #endregion

        public void ToXml(LocalVariable loc, int index, XmlWriter writer) {
            writer.WriteStartElement(TagName);
            writer.WriteAttributeString("index", index.ToString());
            writer.WriteAttributeString("type", Utils.GetFullyQualifiedName(
                loc.Type));
            writer.WriteEndElement();
        }

        public void FromXml(MethodBody mb, XPathNavigator nav) {
            mb.DefineLocalVariable(TypeAdapter.Instance.GetType(
                nav.GetAttribute("type", Utils.ilNS)));
        }
    }
}
