/*
	The contents of this file are subject to the Mozilla Public License Version 1.1 (the "License"); 
	you may not use this file except in compliance with the License. You may obtain a copy of the License at 
	http://www.mozilla.org/MPL/ 
	Software distributed under the License is distributed on an "AS IS" basis, 
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the specific language 
	governing rights and limitations under the License. 

	The Original Code is RAIL(Runtime Assembly Instrumentation Library) Alpha Version.
	The Initial Developer of the Original Code is University of Coimbra,
	Computer Science Department, Dependable Systems Group. Copyright (C) University of Coimbra. 
	All Rights Reserved.  
*/
using System;
using System.Reflection.Emit;

namespace Rail.MSIL {
    /// <summary>
    /// 
    /// </summary>
    /// <remarks>
    /// </remarks>
    internal sealed class OpCodesClassifier {

        private enum InlineVarDetail {
            LocalVar,
            Argument,
            Other
        }

        private static InlineVarDetail GetInlineVarDetail(OpCode op) {
            string type = op.Name.Substring(2, 3);
            if (type == "loc") {
                return InlineVarDetail.LocalVar;
            }
            else if (type == "arg") {
                return InlineVarDetail.Argument;
            }
            return InlineVarDetail.Other;
        }

        public static bool IsArgs(OpCode op) {
            InlineVarDetail t = GetInlineVarDetail(op);
            return t == InlineVarDetail.Argument;
        }

        public static bool IsLocalVariable(OpCode op) {
            InlineVarDetail t = GetInlineVarDetail(op);
            return t == InlineVarDetail.LocalVar;
        }
    }
}
